using System;
using System.Collections;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Threading;

namespace Decal.Interop.Inject;

internal sealed class IViewEvents_EventProvider : IViewEvents_Event, IDisposable
{
	private IConnectionPointContainer m_ConnectionPointContainer;

	private ArrayList m_aEventSinkHelpers;

	private IConnectionPoint m_ConnectionPoint;

	private void Init()
	{
		IConnectionPoint ppCP = null;
		Guid riid = new Guid(new byte[16]
		{
			213, 25, 123, 75, 162, 97, 176, 74, 139, 27,
			56, 26, 48, 58, 147, 127
		});
		m_ConnectionPointContainer.FindConnectionPoint(ref riid, out ppCP);
		m_ConnectionPoint = ppCP;
		m_aEventSinkHelpers = new ArrayList();
	}

	event IViewEvents_OnActivateEventHandler IViewEvents_Event.OnActivate
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IViewEvents_SinkHelper viewEvents_SinkHelper = new IViewEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(viewEvents_SinkHelper, out pdwCookie);
				viewEvents_SinkHelper.m_dwCookie = pdwCookie;
				viewEvents_SinkHelper.m_OnActivateDelegate = value;
				m_aEventSinkHelpers.Add(viewEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IViewEvents_SinkHelper viewEvents_SinkHelper = (IViewEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (viewEvents_SinkHelper.m_OnActivateDelegate != null && ((viewEvents_SinkHelper.m_OnActivateDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(viewEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	event IViewEvents_OnDeactivateEventHandler IViewEvents_Event.OnDeactivate
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IViewEvents_SinkHelper viewEvents_SinkHelper = new IViewEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(viewEvents_SinkHelper, out pdwCookie);
				viewEvents_SinkHelper.m_dwCookie = pdwCookie;
				viewEvents_SinkHelper.m_OnDeactivateDelegate = value;
				m_aEventSinkHelpers.Add(viewEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IViewEvents_SinkHelper viewEvents_SinkHelper = (IViewEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (viewEvents_SinkHelper.m_OnDeactivateDelegate != null && ((viewEvents_SinkHelper.m_OnDeactivateDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(viewEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	event IViewEvents_SizeEventHandler IViewEvents_Event.Size
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IViewEvents_SinkHelper viewEvents_SinkHelper = new IViewEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(viewEvents_SinkHelper, out pdwCookie);
				viewEvents_SinkHelper.m_dwCookie = pdwCookie;
				viewEvents_SinkHelper.m_SizeDelegate = value;
				m_aEventSinkHelpers.Add(viewEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IViewEvents_SinkHelper viewEvents_SinkHelper = (IViewEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (viewEvents_SinkHelper.m_SizeDelegate != null && ((viewEvents_SinkHelper.m_SizeDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(viewEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	event IViewEvents_SizingEventHandler IViewEvents_Event.Sizing
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IViewEvents_SinkHelper viewEvents_SinkHelper = new IViewEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(viewEvents_SinkHelper, out pdwCookie);
				viewEvents_SinkHelper.m_dwCookie = pdwCookie;
				viewEvents_SinkHelper.m_SizingDelegate = value;
				m_aEventSinkHelpers.Add(viewEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IViewEvents_SinkHelper viewEvents_SinkHelper = (IViewEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (viewEvents_SinkHelper.m_SizingDelegate != null && ((viewEvents_SinkHelper.m_SizingDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(viewEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	public IViewEvents_EventProvider(object P_0)
	{
		//Error decoding local variables: Signature type sequence must have at least one element.
		m_ConnectionPointContainer = (IConnectionPointContainer)P_0;
	}

	public void Finalize()
	{
		bool lockTaken = default(bool);
		try
		{
			Monitor.Enter(this, ref lockTaken);
			if (m_ConnectionPoint == null)
			{
				return;
			}
			int count = m_aEventSinkHelpers.Count;
			int num = 0;
			if (0 < count)
			{
				do
				{
					IViewEvents_SinkHelper viewEvents_SinkHelper = (IViewEvents_SinkHelper)m_aEventSinkHelpers[num];
					m_ConnectionPoint.Unadvise(viewEvents_SinkHelper.m_dwCookie);
					num++;
				}
				while (num < count);
			}
			Marshal.ReleaseComObject(m_ConnectionPoint);
		}
		catch (Exception)
		{
		}
		finally
		{
			if (lockTaken)
			{
				Monitor.Exit(this);
			}
		}
	}

	public void Dispose()
	{
		//Error decoding local variables: Signature type sequence must have at least one element.
		Finalize();
		GC.SuppressFinalize(this);
	}
}
